﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace C1Gauge_Color_CS
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        C1.Win.C1Gauge.C1GaugeValueColor c1GaugeValueColor1 = new C1.Win.C1Gauge.C1GaugeValueColor();
        C1.Win.C1Gauge.C1GaugeValueColor c1GaugeValueColor2 = new C1.Win.C1Gauge.C1GaugeValueColor();
        C1.Win.C1Gauge.C1GaugeRectangle C1GaugeRectangle1 = new C1.Win.C1Gauge.C1GaugeRectangle();
        C1.Win.C1Gauge.C1GaugeRectangle C1GaugeRectangle2 = new C1.Win.C1Gauge.C1GaugeRectangle();

        private void Form1_Load(object sender, EventArgs e)
        {
            CB_BackCol.SelectedIndexChanged += CB_BackCol_SelectedIndexChanged;
            CB_BigMarkColor.SelectedIndexChanged += CB_BigMarkColor_SelectedIndexChanged;
            CB_BorderCol.SelectedIndexChanged += CB_BorderCol_SelectedIndexChanged;
            CB_PointerCol.SelectedIndexChanged += CB_PointerCol_SelectedIndexChanged;
            CB_SmallMarkColor.SelectedIndexChanged += CB_SmallMarkColor_SelectedIndexChanged;

            //Large markings
            c1LinearGauge1.Decorators[1].ValueColors.Add(c1GaugeValueColor1);
            c1LinearGauge1.Decorators[1].ValueColors[0].Value = 100;
            c1GaugeValueColor1.Color = Color.Black;

            //Small markings
            c1LinearGauge1.Decorators[2].ValueColors.Add(c1GaugeValueColor2);
            c1LinearGauge1.Decorators[2].ValueColors[0].Value = 100;
            c1GaugeValueColor2.Color = Color.Red;

            //Border
            C1GaugeRectangle1.Border.Color = System.Drawing.Color.Gray;
            C1GaugeRectangle1.Border.Thickness = 1.0;
            C1GaugeRectangle1.CenterPointX = 0.525;
            C1GaugeRectangle1.CornerRadius = 10.0;
            C1GaugeRectangle1.Height = -1.1;
            C1GaugeRectangle1.HitTestable = false;
            C1GaugeRectangle1.Width = -1.2;
            C1GaugeRectangle1.Filling.BrushType = C1.Win.C1Gauge.C1GaugeBrushType.Gradient;
            C1GaugeRectangle1.Gradient.Direction = C1.Win.C1Gauge.C1GaugeGradientDirection.Vertical;
            C1GaugeRectangle1.Filling.Color = Color.Gray;
            C1GaugeRectangle1.Filling.Color2 = Color.Gray;

            //Inner Rectangle
            C1GaugeRectangle2.Filling.BrushType = C1.Win.C1Gauge.C1GaugeBrushType.Gradient;
            C1GaugeRectangle2.Border.Color = Color.Yellow;
            C1GaugeRectangle2.Filling.Color = Color.Yellow;
            C1GaugeRectangle2.Filling.Color2 = Color.Yellow;
            C1GaugeRectangle2.Border.Thickness = 1.0;
            C1GaugeRectangle2.CenterPointX = 0.525;
            C1GaugeRectangle2.CornerRadius = 8.0;
            C1GaugeRectangle2.Height = -0.95;
            C1GaugeRectangle2.HitTestable = false;
            C1GaugeRectangle2.Width = -1.15;

            //Adding the Rectangles
            this.c1LinearGauge1.FaceShapes.AddRange(new C1.Win.C1Gauge.C1GaugeBaseShape[] {C1GaugeRectangle1,C1GaugeRectangle2});


            //Populate ComboBox with Colors
            foreach (System.Reflection.PropertyInfo prop in typeof(Color).GetProperties())
            {
                if (prop.PropertyType.FullName == "System.Drawing.Color")
                {
                    CB_BigMarkColor.Items.Add(prop.Name);
                    CB_BorderCol.Items.Add(prop.Name);
                    CB_PointerCol.Items.Add(prop.Name);
                    CB_SmallMarkColor.Items.Add(prop.Name);
                    CB_BackCol.Items.Add(prop.Name);
                }
            }
        }

        void CB_SmallMarkColor_SelectedIndexChanged(object sender, EventArgs e)
        {
            //Changing the Color of the Small Markings
            string str = CB_SmallMarkColor.SelectedItem.ToString();
            c1GaugeValueColor2.Color = Color.FromName(str);
        }
        void CB_PointerCol_SelectedIndexChanged(object sender, EventArgs e)
        {
            //Changing the Pointer Color
            string str = CB_PointerCol.SelectedItem.ToString();
            c1LinearGauge1.Pointer.Filling.Color = Color.FromName(str);
        }
        void CB_BorderCol_SelectedIndexChanged(object sender, EventArgs e)
        {
            //Changing the Background color
            string str = CB_BorderCol.SelectedItem.ToString();
            C1GaugeRectangle1.Filling.Color = Color.FromName(str);
            C1GaugeRectangle1.Filling.Color2 = Color.FromName(str);
            C1GaugeRectangle1.Border.Color = Color.FromName(str);
        }
        void CB_BigMarkColor_SelectedIndexChanged(object sender, EventArgs e)
        {
            //Changing the Color of the Big Markings
            string str = CB_BigMarkColor.SelectedItem.ToString();
            c1GaugeValueColor1.Color = Color.FromName(str);
        }
        void CB_BackCol_SelectedIndexChanged(object sender, EventArgs e)
        {
            //Changing the Color of the Border
            string str = CB_BackCol.SelectedItem.ToString();
            C1GaugeRectangle2.Border.Color = Color.FromName(str);
            C1GaugeRectangle2.Filling.Color = Color.FromName(str);
            C1GaugeRectangle2.Filling.Color2 = Color.FromName(str);
        }
    }
}
